#include <amxmodx>
#include <fakemeta_util>
#include <cstrike>
#include <hamsandwich>
#include <dhudmessage>

#define PISTOL_MENU                     // Меню выбора пистолета [ закомментируйте если не нужно ]
#if defined PISTOL_MENU
    #define PISTOL_MENU_TYPE                // Открыть меню только в 1 раунде. [ включено ] || Открывать меню всегда. [ закомментируйте ]
#endif

#define MENU_ROUND 3                    // С какого раунда можно открыть WeaponMenu X. [ значение 0 - с любого ]
//#define MENU_AUTO                       // Авто открытие WeaponMenu X
#define LOCKED_WEAPON 2                 // Сколько оружий можно выдать за раунд. [ значение 0 - неограничено ]
#define PACK_GIVE 2                     // С какого раунда выдавать набор. [ значение 1 - с любого ]

#define CHAT_ROUND                      // Чат-сообщение "Доступно с N-ого раунда!"
#define DHUD_ROUND                      // DHUD-сообщение "Доступно с N-ого раунда!"
#define CHAT_MAP                      // Чат-сообщение "На этой карте запрещено брать оружие!"
#define DHUD_MAP                      // DHUD-сообщение "На этой карте запрещено брать оружие!"

#define VIP_ACCESS ADMIN_LEVEL_H        // Флаг доступа ко всему функционалу плагина [ по умолчанию t ]
#define VIP_TAB                         // VIP в табе

//////// Карты на которых не работает плагин - 49 строка. Можно добавить свои через запятую в ковычках или удалить уже существующие. ////////

new pistols[6] = {CSW_USP, CSW_GLOCK18, CSW_ELITE, CSW_FIVESEVEN, CSW_P228, CSW_DEAGLE}
new guns[18] = {CSW_SCOUT, CSW_XM1014, CSW_MAC10, CSW_AUG, CSW_UMP45, CSW_SG550, CSW_GALIL, CSW_FAMAS, CSW_AWP, CSW_MP5NAVY, CSW_M249, CSW_M3, CSW_M4A1, CSW_TMP, CSW_G3SG1, CSW_SG552, CSW_AK47, CSW_P90}
new Menu[5], givingweapon[29], givepack[29], round
new vip_counter[33] = 0
new bool:Block_Map

public plugin_init(){
    register_plugin("WeaponMenu X", "2.0", "MakapoH.")
	
    register_event("HLTV", "RoundStart", "a", "1=0", "2=0")
    register_event("TextMsg", "RoundRestart", "a", "2=#Game_will_restart_in","2=#Game_Commencing")
    register_event("ResetHUD", "startround", "be")
	
    RegisterHam(Ham_Spawn, "player", "player_spawn", 1)
    #if defined PISTOL_MENU
    RegisterHam(Ham_Spawn, "player", "pistol_question", 1)
    #endif
	
    register_clcmd("say /wm", "wm_menu")
    register_clcmd("say_team /wm", "wm_menu")
    register_clcmd("weaponmenu", "wm_menu")
	
    new Map_Name[32], Map_Prefix[][] = { "awp_", "aim_", "35hp", "fy_", "$" }
    get_mapname(Map_Name, charsmax(Map_Name))
    for(new i; i < sizeof Map_Prefix; i++)
	{
        if(containi(Map_Name, Map_Prefix[i]) != -1)
            Block_Map = true
	}
}

public startround(id){
    vip_counter[id] = 0
    #if defined VIP_TAB
    set_task(0.5, "VIP", id + 6910)
    #endif
}

public RoundStart(){
	round++
}
public RoundRestart(){
	round = 0
}

#if defined PISTOL_MENU
public pistol_question(id)
{
    if(is_user_connected(id) && get_user_flags(id) & VIP_ACCESS){
        if(!Block_Map){
            #if defined PISTOL_MENU_TYPE 
			if(round <= 1)
	        #else
			if(round >= 0)
	        #endif
			{
                Menu[1] = menu_create("\yЖелаемый пистолет?", "pistol_give")
                menu_additem(Menu[1], "\wDeagle", "1")
                menu_additem(Menu[1], "\wUSP", "2")
                menu_additem(Menu[1], "\wGlock", "3")
                menu_setprop(Menu[1], MPROP_NUMBER_COLOR, "\r")
                menu_setprop(Menu[1], MPROP_EXITNAME, "\yСпасибо, не надо :)");
                menu_display(id, Menu[1], 0)
			}
		}
	}
}

public pistol_give(id, menu, item){
    if(item == MENU_EXIT)
	{
        menu_destroy(menu)
		
        return PLUGIN_HANDLED
    }

    new Data[6], Name[64], Access, Callback
    menu_item_getinfo(menu, item, Access, Data, charsmax(Data), Name, charsmax(Name), Callback)

    new Key = str_to_num(Data)
    has_weapon_pistols(id)
    switch(Key)
	{
        case 1:
		{
            fm_give_item(id, "weapon_deagle")
            cs_set_user_bpammo(id, CSW_DEAGLE, 35)
		}
        case 2:
		{
            fm_give_item(id, "weapon_usp")
            cs_set_user_bpammo(id, CSW_USP, 100)
		}
        case 3:
		{
            fm_give_item(id, "weapon_glock18")
            cs_set_user_bpammo(id, CSW_GLOCK18, 120)
		}
    }
    menu_destroy(menu)
	
    return PLUGIN_HANDLED
}
#endif

public player_spawn(id){
    if(is_user_connected(id) && get_user_flags(id) & VIP_ACCESS){
        if(!Block_Map){
            if(round >= PACK_GIVE)
			{
                has_weapon_pistols(id)
                pack(id)
			}
            #if defined MENU_AUTO
            if(round >= MENU_ROUND) wm_menu(id)
			#endif
		}
	}
}

public wm_menu(id){
    if(is_user_connected(id))
	{
        if(get_user_flags(id) & VIP_ACCESS)
		{
            if(!Block_Map)
			{
                if(round >= MENU_ROUND)
				{
                    Menu[2] = menu_create("\yОружейка", "wm_handler")
                    menu_additem(Menu[2], "\wM4A1 + \d[\rНабор\d]", "1")
                    menu_additem(Menu[2], "\wAK47 + \d[\rНабор\d]", "2")
                    menu_additem(Menu[2], "\wFAMAS + \d[\rНабор\d]", "3")
                    menu_additem(Menu[2], "\wAWP + \d[\rНабор\d]^n", "4")
                    menu_additem(Menu[2], "\r[\yПистолеты\r]", "5")
                    menu_setprop(Menu[2], MPROP_NUMBER_COLOR, "\y")
                    menu_setprop(Menu[2], MPROP_EXITNAME, "\rВыход")
                    menu_display(id, Menu[2], 0)
			    }
			    else
			    {
                   #if defined CHAT_ROUND
                   ChatColor(id, "^1[^3WeaponMenu X^1] Доступно с ^3%d-го ^1раунда!", MENU_ROUND)
				   #endif
				   #if defined DHUD_ROUND
                   set_dhudmessage(255, 255, 0, -1.0, 0.30, 0, 0.1, 3.0, 0.1, 0.5)
                   show_dhudmessage(id, "Доступно с %d-го раунда!", MENU_ROUND)
				   #endif
			    }
			}
            else
            {
                #if defined CHAT_MAP
                ChatColor(id, "^1[^3WeaponMenu X^1] На этой карте запрещено брать оружие!")
				#endif
				#if defined DHUD_MAP
                set_dhudmessage(255, 255, 0, -1.0, 0.30, 0, 0.1, 3.0, 0.1, 0.5)
                show_dhudmessage(id, "На этой карте запрещено брать оружие!")
				#endif
			}
		}
		else client_print(id, print_console, "[WeaponMenu X] У вас недостаточно прав!")
	}
    return PLUGIN_HANDLED
}

public wm_handler(id, menu, item){
    if(item == MENU_EXIT)
	{
        menu_destroy(menu)
		
        return PLUGIN_HANDLED
	}

    new Data[6], Name[64], Access, Callback
    menu_item_getinfo(menu, item, Access, Data, charsmax(Data), Name, charsmax(Name), Callback)

    new Key = str_to_num(Data)
    switch(Key)
	{
        case 1:selectplayer(id, 22, 1)
        case 2:selectplayer(id, 28, 1)
        case 3:selectplayer(id, 15, 1)
		case 4:selectplayer(id, 18, 1)
		case 5:pistols_menu(id)
    }
    menu_destroy(menu)
	
    return PLUGIN_HANDLED
}

public selectplayer(id, weapon, pack){
    givingweapon[id] = weapon
    givepack[id] = pack
	
    Menu[3] = menu_create("\wКому выдать?", "give_rifle")
	
    new s_Players[32], i_Num, i_Player
    new s_Name[64], s_Player[10]
    get_players(s_Players, i_Num)
    for (new i; i < i_Num; i++)
	{
        i_Player = s_Players[i]

        get_user_name(i_Player, s_Name, charsmax(s_Name))
        num_to_str(i_Player, s_Player, charsmax(s_Player))
        if(is_user_alive(i_Player)) format(s_Name, charsmax(s_Name), "\w%s", s_Name)
        else format(s_Name, charsmax(s_Name), "\d%s", s_Name)
		
        menu_additem(Menu[3], s_Name, s_Player, 0)
        menu_setprop(Menu[3], MPROP_NEXTNAME, "\yДалее")
        menu_setprop(Menu[3], MPROP_BACKNAME, "\yНазад")
        menu_setprop(Menu[3], MPROP_EXITNAME, "\rВыбор оружия")
    }
    menu_display(id, Menu[3], 0)
}

public give_rifle(id, menu, item){
    if(item == MENU_EXIT)
	{
        menu_destroy(menu)
        wm_menu(id)
		
        return PLUGIN_HANDLED
    }

    new Data[6], Name[64], Access, Callback
    menu_item_getinfo(menu, item, Access, Data, charsmax(Data), Name, charsmax(Name), Callback)

    new i_Player = str_to_num(Data)

    if(is_user_connected(i_Player) && is_user_alive(i_Player)){
        if(vip_counter[id] < LOCKED_WEAPON)
		{
            has_weapon_guns(i_Player)
            switch(givingweapon[id])
			{
                case 28:
				{
                    fm_give_item(i_Player, "weapon_ak47")
                    cs_set_user_bpammo(i_Player, givingweapon[id], 90)
                    vip_counter[id]++
                }
                case 22:
				{
                    fm_give_item(i_Player, "weapon_m4a1")
                    cs_set_user_bpammo(i_Player, givingweapon[id], 90)
                    vip_counter[id]++
                }
				case 15:
				{
                    fm_give_item(i_Player, "weapon_famas")
                    cs_set_user_bpammo(i_Player, givingweapon[id], 90)
                    vip_counter[id]++
                }
                case 18:
				{
                    fm_give_item(i_Player, "weapon_awp")
                    cs_set_user_bpammo(i_Player, givingweapon[id], 30)
                    vip_counter[id]++
                }
		    }
            if(givepack[id]) pack(id)
		}
        else
		{
            ChatColor(id, "^1[^3WeaponMenu X^1] ^4За раунд можно выдать только %d оружия!", LOCKED_WEAPON)
            set_dhudmessage(255, 255, 0, -1.0, 0.30, 0, 0.1, 3.0, 0.1, 0.5)
            show_dhudmessage(id, "За раунд можно выдать только %d оружия!", LOCKED_WEAPON)
	    }
    }
    menu_destroy(menu)
    selectplayer(id, givingweapon[id], givepack[id])

    return PLUGIN_HANDLED
}

public pistols_menu(id){
    if(is_user_alive(id))
	{
        Menu[4] = menu_create("\yЖелаемый пистолет?", "pistols_handler")
        menu_additem(Menu[4], "Deagle", "1")
        menu_additem(Menu[4], "USP", "2")
        menu_additem(Menu[4], "Glock", "3")
        menu_setprop(Menu[4], MPROP_NUMBER_COLOR, "\y")
        menu_setprop(Menu[4], MPROP_EXITNAME, "\rВ меню")
        menu_display(id, Menu[4], 0)
	}
    return PLUGIN_HANDLED
}

public pistols_handler(id, menu, item){
    if(item == MENU_EXIT)
	{
        menu_destroy(menu)
        wm_menu(id)
		
        return PLUGIN_HANDLED
	}

    new Data[6], Name[64], Access, Callback
    menu_item_getinfo(menu, item, Access, Data, charsmax(Data), Name, charsmax(Name), Callback)

    new Key = str_to_num(Data)
	
    if(vip_counter[id] < LOCKED_WEAPON)
	{
        has_weapon_pistols(id)
        switch(Key)
		{
            case 1:
			{
                fm_give_item(id, "weapon_deagle")
                cs_set_user_bpammo(id, CSW_DEAGLE, 35)
                vip_counter[id]++
		    }
            case 2:
			{
                fm_give_item(id, "weapon_usp")
                cs_set_user_bpammo(id, CSW_USP, 100)
                vip_counter[id]++
		    }
            case 3:
			{
                fm_give_item(id, "weapon_glock18")
                cs_set_user_bpammo(id, CSW_GLOCK18, 120)
                vip_counter[id]++
			}
		}
    }
    else
	{
        ChatColor(id, "^1[^3WeaponMenu X^1] ^4За раунд можно выдать только %d оружия!", LOCKED_WEAPON)
        set_dhudmessage(255, 255, 0, -1.0, 0.30, 0, 0.1, 3.0, 0.1, 0.5)
        show_dhudmessage(id, "За раунд можно выдать только %d оружия!", LOCKED_WEAPON)
	}
    wm_menu(id)
	
    return PLUGIN_HANDLED
}
public pack(id){
    fm_give_item(id, "weapon_deagle")
    fm_give_item(id, "weapon_hegrenade")
    fm_give_item(id, "weapon_flashbang")
    fm_give_item(id, "weapon_flashbang")
    fm_give_item(id, "weapon_smokegrenade")
    cs_set_user_bpammo(id, CSW_DEAGLE, 35)
    cs_set_user_armor(id, 100, CsArmorType:2)
    if(cs_get_user_team(id) == CS_TEAM_CT) fm_give_item(id,"item_assaultsuit")
}

#if defined VIP_TAB
public VIP(TaskID){
    new id = TaskID - 6910
	
    if (is_user_connected(id) && get_user_flags(id) & VIP_ACCESS)
	{
        message_begin(MSG_ALL, get_user_msgid("ScoreAttrib"))
        write_byte(id)
        write_byte(4)
        message_end()
	}
}
#endif

public has_weapon_guns(i_Player){
    for (new wpn=0; wpn<18; wpn++)
	{
        fm_strip_user_gun(i_Player, guns[wpn])
	}
}

public has_weapon_pistols(id){
    for (new wpn=0; wpn<6; wpn++)
	{
        fm_strip_user_gun(id, pistols[wpn])
	}
}

stock ChatColor(const id, const szMessage[], any:...){
	static pnum, players[32], szMsg[190], IdMsg;
	vformat(szMsg, charsmax(szMsg), szMessage, 3)
	
	if(!IdMsg) IdMsg = get_user_msgid("SayText")
	
	if(id) 
	{
		if(!is_user_connected(id)) return 0
		players[0] = id
		pnum = 1;
	} 
	else get_players(players, pnum, "ch")
	
	for(new i; i < pnum; i++)
	{
		message_begin(MSG_ONE, IdMsg, .player = players[i])
		write_byte(players[i])
		write_string(szMsg)
		message_end()
	}
	return 1
}